#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <pthread.h>
#include <gtk/gtk.h>

#define OZEDIT_VERSION 0
#define OZEDIT_SUBVERSION 1 
#define OZEDIT_PATCH 0
#define OZEDIT_PRERELEASE 3

#define OZEDIT_RELEASE_DATE "24/07/2003"

#define OBJECT_TYPE_NONE 0
#define OBJECT_TYPE_UNKNOWN 1
#define OBJECT_TYPE_CHEADER 2
#define OBJECT_TYPE_CSOURCE 3
#define OBJECT_TYPE_JAVASOURCE 4
#define OBJECT_TYPE_PERL 5
#define OBJECT_TYPE_HTML 6
#define OBJECT_TYPE_CPPSOURCE 7
#define OBJECT_TYPE_BASH 8

#define OBJECT_STATUS_OK 0
#define OBJECT_STATUS_NEW 1
#define OBJECT_STATUS_UNSAVED 2

#ifdef DEBUG
#warning "DEBUG Messages Enabled"
#endif

struct _OzEDIT_Bookmark {
    gchar name[64]; /* Nome del Bookmark */
    gchar bk_name[64]; /* Nome del Bookmark da Visualizzare */
    GtkTreeIter treeiter;
};

struct _OzEDIT_Object {
    gchar name[255];
    gchar filename[255];
    guint type;   /* Tipo di oggetto */
    guint status; /* Stato dell'oggetto */
    gboolean colorized; /* Colorato ? Per risparmiare cicli di CPU */
    guint frame_id; /* ID Progressivo del FRAME */
    GList *bookmarks;
    guint bk_count; /* Contatore dei BookMarks */
    GtkWidget *frame,*w_textview,*w_scrolled,*w_label,*w_entry,*w_vbox;
    GdkColor color;
    GtkTextTag *tag_blue,*tag_red,*tag_green,*tag_gray,*tag_graybg;
    GtkTextBuffer *text_buffer;
    GtkTreeIter treeiter;
    GQueue *listundo,*listredo; /* Lista delle modifiche per Undo & Redo functions */
};

struct _OzEDIT_TopClass {
    gchar wsname[255];
    gchar wsfilename[255];
    GList *objects,*recentfiles;
    GtkWidget *notebook,*statusbar,*maintree,*console;
    GtkTreeStore *treestore;
    guint notebook_current_page,current_frame_id;
    guint object_counter;
    GdkPixbuf *pixbuf_bookmark;
    gboolean need_update;
    gchar update_message[512];
};

struct _OzGtkXML {
    gchar name[128];     /* Nome */
    gchar value[128];    /* Valore */
    GList *Elements; /* Lista degli elementi (Sottoelementi) */
    struct _OzGtkXML *Parent; /* Puntatore alla struttura padre */
};

struct _OzEDIT_Config {
    gboolean autocheck_for_updates; 		/* YES/NO Controlla aggiornamenti automaticamente */
    gboolean colorize_code;			/* YES/NO Colora automaticamente il codice sorgente */
    guint lenght_recent_files_list;		/* Lunghezza lista files recenti */
    PangoFontDescription *font_textbuffer;	/* Fonts */	
} OzEDIT_Config;

struct _OzEDIT_RecentFile {
    gchar name[256];
    GtkTreeIter treeiter;
};
