/*
===============================================================================
=== Released under GPL (GNU Public License) ==== No Any Warranty ==============
===============================================================================

- Rilevare le FUNZIONI ed aggiungerle al Tree View
- Usare moduli per il parsing dei linguaggi

*/

#include "../include/common.h"
#include "../include/parser.h"


GList *ListLangDefs;
void OzEDIT_LoadLangDefinition(gint);

struct _OzEDIT_Definition *OzEDIT_ReturnDefsFromType(gint type) {
    struct _OzEDIT_Definition *defs;    
    guint n;
    for(n=0;n<g_list_length(ListLangDefs);n++) {
        defs = g_list_nth_data(ListLangDefs,n);		
        if(defs->type == type) return defs; /* Gia' caricata, vai ! */
    } 
    return NULL;
}

/* === Parse Text Buffer (and colorize it !) ================================== */
guint OzEDIT_TokenAnalyze(gchar *token,gint type) {
    struct _OzEDIT_Definition *defs;
    struct _OzEDIT_Token *tok;
    guint i,ttype;
    defs = OzEDIT_ReturnDefsFromType(type);
    if(defs == NULL) return TOKEN_UNKNOWN;
    for(i=0;i<g_list_length(defs->tokens);i++) {
	tok = g_list_nth_data(defs->tokens,i);		
	if(defs->case_sensitive == FALSE) {
	    if(g_ascii_strncasecmp(tok->data,token,strlen(tok->data))==0) {
		return tok->type;
	    }
	} else {
#warning "WARNING: Find a function for NON CASE-SENSITIVE comparing."
	    if(g_ascii_strncasecmp(tok->data,token,strlen(tok->data))==0) {
		return tok->type;
	    }
	}
    }
    return TOKEN_UNKNOWN;
}	

gboolean is_parentesis(gchar c) {
/* Le parentesi non sono valide ! */
    if((c == '(')||(c == ')')||(c == ']')||(c == '[')||(c == '{')||(c == '}')) {
        return TRUE;
    } else {
	return FALSE;
    }
}

gboolean is_valid(gchar c) {
/* Le parentesi non sono valide ! */
    if((c == '(')||(c == ')')||(c == ']')||(c == '[')||(c == '{')||(c == '}')) return FALSE;
/* Anche ; e : non sono validi ! */
    if((c == ';')||(c == ';')) return FALSE;
    if(c == '\n') return FALSE;
    if(c == ' ') return FALSE;
/* ALFABETO+NUMERI+SIMBOLI */
    if((g_unichar_isalnum(c))||(g_unichar_ispunct(c))) {
	return TRUE;
    } else {
	return FALSE;
    }
}

void OzEDIT_ParseTextBuffer(struct _OzEDIT_Object *object) {
    GtkTextIter i_start,i_end,i_cstart,i_cend,i_pstart,i_pend,i_sstart,i_send;
    gchar *buffer,*index,token[256];
    gulong sizeofbuffer,offset,ti,xffset;
    gboolean is_comment,is_string,is_double_hypen,is_single_hypen;
    /* Verifica se  un TIPO di file che possiamo colorare... */
    if((object->type == OBJECT_TYPE_UNKNOWN)||(object->type == OBJECT_TYPE_NONE)) return;
    /* Carica definizione del file */
    OzEDIT_LoadLangDefinition(object->type);
    /* Crea ITERs */
    gtk_text_buffer_get_start_iter(object->text_buffer,&i_start);
    gtk_text_buffer_get_end_iter(object->text_buffer,&i_end);
    /* Rimuovi tutti i TAGs */
    gtk_text_buffer_remove_all_tags(object->text_buffer,&i_start,&i_end);
    /* Alloca la memoria necessaria */
    sizeofbuffer = gtk_text_buffer_get_char_count(object->text_buffer);
    buffer = g_malloc0(sizeofbuffer);
    /* Prelev il buffer */
    buffer = gtk_text_buffer_get_text(object->text_buffer,&i_start,&i_end,FALSE);
    ti = 0;
    is_string = is_comment = is_single_hypen = is_double_hypen = FALSE;
    for(offset = 0;offset < (sizeofbuffer+1);offset++) {
	if((is_parentesis(buffer[offset]))&&(is_comment == FALSE)&&(is_string == FALSE)) {
    	    gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_pstart,offset);
	    gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_pend,offset+1);
	    gtk_text_buffer_apply_tag(object->text_buffer,object->tag_blue,&i_pstart,&i_pend);
	}
	if(buffer[offset] == '"') {
	    if(!is_comment) {
    		if(is_string == FALSE) {
		    gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_sstart,offset);
		    is_string = TRUE;
		    is_double_hypen = TRUE;
		} else {
		    if(is_double_hypen == TRUE) {
    			gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_send,offset+1);
			gtk_text_buffer_apply_tag(object->text_buffer,object->tag_green,&i_sstart,&i_send);
			is_string = FALSE;
			is_double_hypen = FALSE;
		    }
    		}
	    }
	}
	if(buffer[offset] == '\'') {
	    if(!is_comment) {
    		if(is_string == FALSE) {
		    gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_sstart,offset);
		    is_string = TRUE;
		    is_single_hypen = TRUE;
		} else {
		    if(is_single_hypen == TRUE) {
    			gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_send,offset+1);
			gtk_text_buffer_apply_tag(object->text_buffer,object->tag_green,&i_sstart,&i_send);
			is_string = FALSE;
			is_single_hypen = FALSE;
		    }
    		}
	    }
	} 
	if(is_string == FALSE) {
	    if((is_valid(buffer[offset]))) {  /* Alfanumerico o Simbolo */
		token[ti] = buffer[offset];
		ti++;
		token[ti] = '\0';
		if(ti > 255) ti = 0;
	    } else if(ti > 0) { /* Altrimenti analizza il TOKEN */
    	        gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_start,offset-strlen(token));
		gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_end,offset);
#ifdef DEBUG
		g_print("DEBUG: -TokenAnalyze- %s -> %d ",token,OzEDIT_TokenAnalyze(token,object->type));
		if(is_comment) g_print("IS_COMMENT ");
		if(is_string) g_print("IS_STRING ");		
		g_print("\n");
#endif		
		switch(OzEDIT_TokenAnalyze(token,object->type)) {
	    	    case TOKEN_RESERVEDWORD:
			if(is_comment == FALSE) gtk_text_buffer_apply_tag(object->text_buffer,object->tag_blue,&i_start,&i_end);			    								    
			break;			    
		    case TOKEN_PREPROCESSOR:
			if(is_comment == FALSE) gtk_text_buffer_apply_tag(object->text_buffer,object->tag_red,&i_start,&i_end);
			break;			    
		    case TOKEN_STARTCOMMENTBLOCK:
	    		if(is_comment == FALSE) gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_cstart,offset-strlen(token));
			is_comment = TRUE;
			break;
		    case TOKEN_ENDCOMMENTBLOCK:		    
			if(is_comment == TRUE) {
			    gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_cend,offset);
			    /* Colorize ! */
			    gtk_text_buffer_apply_tag(object->text_buffer,object->tag_gray,&i_cstart,&i_cend);			    								    		    
			    is_comment = FALSE;
			}
			break;
		    case TOKEN_LINECOMMENT:		    
	    		if(is_comment == FALSE) {
			    gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_cstart,offset-strlen(token));
			    gtk_text_buffer_get_iter_at_offset(object->text_buffer,&i_cend,offset);
			    gtk_text_iter_forward_to_line_end(&i_cend);
			    gtk_text_buffer_apply_tag(object->text_buffer,object->tag_gray,&i_cstart,&i_cend);			    								    		    			    			    
			}			    			
		    default:
			break;
		}
		ti=0;
	    }
	}
    }    
    /* Libera tutto... */
    g_free(buffer);
}


void OzEDIT_LoadLangDefinition(gint langtype) {
    struct _OzGtkXML *XMLRoot, *XMLTemp;
    struct _OzEDIT_Token *token;
    struct _OzEDIT_Definition *defs;
    
    gchar filename[128];
    gint n,type;

    /* Lista delle definizioni caricate in memoria */
    if(ListLangDefs != NULL) {
	for(n=0;n<g_list_length(ListLangDefs);n++) {
	    defs = g_list_nth_data(ListLangDefs,n);		
	    if(defs->type == langtype) return; /* Gia' caricata, vai ! */
	}
    }
    /* carica la definizione... */
    defs = g_malloc0(sizeof(struct _OzEDIT_Definition));
    defs->type = langtype;

    g_stpcpy(filename,DEFINITIONS_BASEPATH);
    
    switch(langtype) {
	case OBJECT_TYPE_CHEADER:
    	case OBJECT_TYPE_CSOURCE:
	    g_strlcat(filename,DEFINITIONS_C_LANG,128);	        
	    break;
	case OBJECT_TYPE_JAVASOURCE:
	    g_strlcat(filename,DEFINITIONS_JAVA_LANG,128);	        
	    break;
	case OBJECT_TYPE_PERL:
	    g_strlcat(filename,DEFINITIONS_PERL_LANG,128);	        	
	    break;
	case OBJECT_TYPE_HTML:
	    g_strlcat(filename,DEFINITIONS_HTML_LANG,128);	        	
	    break;
	case OBJECT_TYPE_CPPSOURCE:
	    g_strlcat(filename,DEFINITIONS_CPP_LANG,128);	        	
	    break;
	case OBJECT_TYPE_BASH:
	    g_strlcat(filename,DEFINITIONS_BASH_LANG,128);	        	
	    break;
	default:  return;
	    break;  
    }

    XMLRoot = (struct _OzGtkXML *)OzGtkXML_ParseFile(filename);
    if(XMLRoot == NULL) {
	OzEDIT_ErrorDialog("Cannot load %s definitions file |",filename);
	return;
    }
    /* ORA INTERPRETA IL FILE */
    XMLRoot = (struct _OzGtkXML *)OzGtkXML_GetElementFromName(XMLRoot,"Language");
    if(XMLRoot == NULL) {
	OzEDIT_ErrorDialog("Invalid definitions file %s !",filename);
	return;
    }
    /* Adesso carica le definizioni */
    for(n=0;n<g_list_length(XMLRoot->Elements);n++) {
	XMLTemp = g_list_nth_data(XMLRoot->Elements,n);
#ifdef DEBUG
	g_print("%d - %s(%s)\n",n,XMLTemp->name,XMLTemp->value);
#endif	
	token = g_malloc0(sizeof(struct _OzEDIT_Token));
	if(g_ascii_strncasecmp(XMLTemp->name,"CaseSensitive",strlen(XMLTemp->name))==0) {
	    if(g_ascii_strncasecmp(XMLTemp->value,"YES",strlen(XMLTemp->value))==0) {
		defs->case_sensitive = TRUE;
	    } else {
		defs->case_sensitive = FALSE;
	    }
	}
	if(g_ascii_strncasecmp(XMLTemp->name,"ReservedWord",strlen(XMLTemp->name))==0) {
	    token->type = TOKEN_RESERVEDWORD;
	} else if(g_ascii_strncasecmp(XMLTemp->name,"CompilerType",strlen(XMLTemp->name))==0) {
	    token->type = TOKEN_PREPROCESSOR;
	} else if(g_ascii_strncasecmp(XMLTemp->name,"CommentBlockStart",strlen(XMLTemp->name))==0) {
	    token->type = TOKEN_STARTCOMMENTBLOCK;
	} else if(g_ascii_strncasecmp(XMLTemp->name,"CommentBlockEnd",strlen(XMLTemp->name))==0) {
	    token->type = TOKEN_ENDCOMMENTBLOCK;
	} else if(g_ascii_strncasecmp(XMLTemp->name,"CommentLine",strlen(XMLTemp->name))==0) {
	    token->type = TOKEN_LINECOMMENT;
	}	
	g_strlcpy(token->data,XMLTemp->value,80);
	defs->tokens = g_list_append(defs->tokens,token);
	/* Libera la memoria */
	g_free(XMLTemp);
    }
    /* Libera la memoria della lista */
    g_list_free(XMLRoot->Elements);
    g_free(XMLRoot);
/* Aggiungi la definizione caricata alla lista definizioni */
    ListLangDefs = g_list_append(ListLangDefs,defs);
}
