
#include<ImLib3D.hpp>
#include<ImLib3D/TestPatterns.hpp>
#include<ImLib3D/MorphologicalOperators.hpp>
#include<ImLib3D/FFT.hpp>

// Demonstrates the use of image processors

int
main(int argc,char **argv)
{
	// create a sphere for use in these examples
	Image3Df sphere;
	IP3D::Sphere(Size3D(100,100,100),Vect3Df(50,50,50),10,sphere);
	
	// Erosion 
	Mask3D ima(100,100,100);
	ima=sphere;
	IP3D::Erosion(ima,StructureElement(MORPHO_Cross7),ima);

	// Distance Transform
	Image3Df dist;
	IP3D::DistanceTransform(ima,StructureElement(MORPHO_Cross7),dist);

#ifdef HAS_FFTW

	// Complex->Complex Fourier transform
	Image3Dcomplex im(100,100,100);
	Image3Dcomplex res;
	im=sphere;
	IP3D::FFTDouble(im,res);

#endif // HAS_FFTW

}
